#!/usr/bin/perl

###############################################
# Cacti Drag-and-Drop CGI
# 
# Be warned: This isn't the most elegant animal...
# - C.J. Fournier

$| = 1 ;

use strict ;
use DBI ;
use CGI qw(:standard) ;
use JSON ;
use Sort::Key::OID qw(oidsort) ;

# Read DB credentials out of 'config.php'
my $useConfig = 1 ;

# Toggle for live DB changes or not (debugging)
my $liveRounds = 1 ;
my $doBackups  = 1 ;

our %HOST ;
our %GRAPH_TREE ;
our %treeObj ;

my $cgi_param ;
my $json ;
my $op_status ;

my $db_username ;
my $db_password ;
my $db_default ;
my $db_hostname ;
my $db_port ;


# Icons here are a bit of a cheat, since they should go into the JS,
# but haven't figured out how to properly work them into the tree :(
my $icon_tree   = "lib/img/tree.png" ;
my $icon_header = "lib/img/page_header_footer.png" ; 
my $icon_graph  = "lib/img/Chart-Graph-Descending-icon.png" ;

print header('application/json');

if ($useConfig) {
	# Cheap hack -- Open the config.php file and read the DB creds
	my $cf ; 
	open(R,'../../include/config.php') ; $/ = \000 ;
	$cf = <R> ;
	close(R) ;
	
	$db_username = $1 if $cf =~ /database_username = "(\S+)"/m ;
	$db_password = $1 if $cf =~ /database_password = "(\S+)"/m ;
	$db_default  = $1 if $cf =~ /database_default = "(\S+)"/m ;
	$db_hostname = $1 if $cf =~ /database_hostname = "(\S+)"/m ;
	$db_port     = $1 if $cf =~ /database_port = "(\S+)"/m ;
}

my $dsn = "DBI:mysql:database=$db_default;host=$db_hostname;port=$db_port";
my $dbh = DBI->connect($dsn, $db_username, $db_password);

my $cgi = new CGI;
if (request_method() eq 'GET') {
	$cgi_param = $cgi->param('tree') ;
	$json = new JSON;
	graph_tree() if !$cgi_param  ;
	avail_graphs_tree() if $cgi_param eq 'avail' ;
	if ($cgi_param eq 'nextTree') {
		print $json->encode(\@{next_tree_ID()}) ;
	}
}
elsif (request_method() eq 'POST') {

	$cgi_param = $cgi->param("POSTDATA");         

	$json = new JSON;
	$json = decode_json($cgi_param) ;

	$op_status .= backup() if $doBackups ;
	$dbh->do("DELETE FROM graph_tree;") if $liveRounds ;
	$dbh->do("DELETE FROM graph_tree_items;") if $liveRounds ;
	foreach my $t (@{$json}) {
		treewalk(\%{$t}) ;
	}
	# If we made it this far...
	$op_status = "{ \"commit\": \"commit successful\", \"backup\": \"none\"}" if !$doBackups ;
	$op_status = "{ \"commit\": \"commit successful\", \"backup\": \"$op_status\"}" if $doBackups ;
	print $op_status . "\n" ;
}

exit ;

sub graph_tree {

	###########################################
	# Turns existing trees into JSON data

	my $tab_X ;
	my $ref ;
	my $node_id = 1 ;
	my $node_counter ;
	my $c ;
	my $branch_ID ;
	my $last_tab_X ;
	my ($parent_ID, $last_branch_ID) ;
	my $k_ID ;

	my $sth= $dbh->prepare("SELECT  graph_tree.id,
					graph_tree.name,
					graph_tree_items.id as graph_tree_item_id,
					graph_tree_items.title,
					graph_tree_items.local_graph_id,
					graph_tree_items.order_key,
					graph_templates_graph.title_cache 
				FROM graph_tree 
					LEFT JOIN graph_tree_items on graph_tree.id = graph_tree_items.graph_tree_id 
					LEFT JOIN graph_templates_graph on graph_tree_items.local_graph_id = graph_templates_graph.local_graph_id AND 
					          graph_templates_graph.local_graph_id != 0;
	") ;
	$sth->execute ;
	while (my $ref = $sth->fetchrow_hashref()) {

		$GRAPH_TREE{$$ref{'id'}}->{'name'} = $$ref{'name'} ;

		# Convert the order key to an OID
	 	my @triples = $$ref{'order_key'} =~ m/(...)/g ;
	 	$k_ID = '' ;
	 	foreach my $t (@triples) {
	 		$t =~ s/^0*// ;
	 		last if !$t ;
	 		$k_ID .= "$t." ;
	 	}
	 	$k_ID =~ s/.$// ;
	
	 	$GRAPH_TREE{$$ref{'id'}}->{'tree'}->{$k_ID}->{$$ref{'graph_tree_item_id'}}->{'title'}             	= $$ref{'title'} ;
	 	$GRAPH_TREE{$$ref{'id'}}->{'tree'}->{$k_ID}->{$$ref{'graph_tree_item_id'}}->{'local_graph_id'}          = $$ref{'local_graph_id'} ;
	 	$GRAPH_TREE{$$ref{'id'}}->{'tree'}->{$k_ID}->{$$ref{'graph_tree_item_id'}}->{'title_cache'}		= $$ref{'title_cache'} ;
	
	}
	
	my $num_ids = keys %GRAPH_TREE ;
	print "[{\n" ;
	foreach my $tree (sort keys %GRAPH_TREE) {
	 	print "\t\"key\":\"$tree\",\n\t\"title\":\"$GRAPH_TREE{$tree}->{'name'}\",\n\"icon\":\"$icon_tree\",\n\"folder\":\"true\",\n\t\"state\":\"closed\"\n"; 
		$last_tab_X = 1;
	
		foreach my $B (oidsort (keys %{$GRAPH_TREE{$tree}->{'tree'}})) {
			if (!$B) {
				$tab_X = 1 ;
				last ;
			}
			
			$branch_ID = $tree . '.' . $B ; 
	
	 		foreach my $G_ID (sort {$a <=> $b} keys %{$GRAPH_TREE{$tree}->{'tree'}->{$B}}) {
	
				$tab_X = (scalar split(/\./,$B)+1) ;
	
				if ($tab_X < $last_tab_X) {
					for (my $c = ($last_tab_X-1) ;$c > ($tab_X-1) ; $c--) {
						printf "\t"x($c) ; print "}]\n" ;
					}
	
					if ($tab_X > 1) {
						printf "\t"x($c) ; print "},{\n" ;
					}
				}
	
				if ($tab_X > $last_tab_X) {
					printf "\t"x(($tab_X)-1) ; print ",\n" ;
					printf "\t"x(($tab_X)-1) ; print "\"children\":[{\n" ;
	
				}
				if ($tab_X == $last_tab_X) {
					printf "\t"x($tab_X) ; print "},{\n" ;
				}
	
				printf "\t"x($tab_X) ; print "\"key\":\"$branch_ID\",\n" ;
				$parent_ID = $branch_ID ; $parent_ID =~ s/\.\d+$// ;
				printf "\t"x($tab_X) ; print "\"parentid\":\"$parent_ID\",\n"  ;
	
				if (!$GRAPH_TREE{$tree}->{'tree'}->{$B}->{$G_ID}->{'local_graph_id'}) {
					printf "\t"x($tab_X) ; print "\"title\":\"$GRAPH_TREE{$tree}->{'tree'}->{$B}->{$G_ID}->{'title'}\",\n"  ;
					printf "\t"x($tab_X) ; print "\"folder\":\"true\",\n"  ;
					printf "\t"x($tab_X) ; print "\"icon\":\"$icon_header\",\n"  ;
					printf "\t"x($tab_X) ; print "\"attributes\":{\n" ;
					printf "\t"x($tab_X) ; print "\t\"type\":\"header\",\n" ;
					printf "\t"x($tab_X) ; print "\t\"graph_tree_item_id\":\"$G_ID\"\n" ;
					printf "\t"x($tab_X) ; print "}\n" ;
				}
				else {
	 				printf "\t"x($tab_X) ; print "\"title\":\"$GRAPH_TREE{$tree}->{'tree'}->{$B}->{$G_ID}->{'title_cache'} ($GRAPH_TREE{$tree}->{'tree'}->{$B}->{$G_ID}->{'local_graph_id'})\",\n" ;
					printf "\t"x($tab_X) ; print "\"icon\":\"$icon_graph\",\n"  ;
					printf "\t"x($tab_X) ; print "\"attributes\":{\n" ;
					printf "\t"x($tab_X) ; print "\t\"type\":\"graph\",\n" ;
					printf "\t"x($tab_X) ; print "\t\"graph_tree_item_id\":\"$G_ID\",\n" ;
					printf "\t"x($tab_X) ; print "\t\"local_graph_id\":\"$GRAPH_TREE{$tree}->{'tree'}->{$B}->{$G_ID}->{'local_graph_id'}\"\n" ;
					printf "\t"x($tab_X) ; print "}\n" ;
				}
				
				$last_tab_X = $tab_X ;
	 		}
	
			$last_branch_ID = $branch_ID if length($branch_ID) > length($last_branch_ID) ;
		}
	 	$node_id++ ; $node_counter = 1 ;
	
		for ($c = $tab_X ;$c > 1 ; $c--) {
			printf "\t"x($c) ; print "}]\n" ;
		}
	
		print "\t},{\n" if $node_id <= $num_ids ;
	}
	print "}]\n" ;
}

sub avail_graphs_tree {

	###########################################
	# Generates a two-tier list of graphs and their respective devices (for selection)

	my $node_id = 1 ;
	my $node_counter = 1 ;
	my $node_ref ;
	my $num_elements ;
	my ($h, $t, $g) ;

	my $sth= $dbh->prepare("SELECT host.id, 
					description,
					graph_templates_graph.title_cache,
					graph_templates_graph.local_graph_id 
				FROM graph_local
				 left join graph_templates_graph on graph_local.id = graph_templates_graph.local_graph_id
				 left join host on graph_local.host_id = host.id
				ORDER BY host.description,graph_templates_graph.title_cache,graph_templates_graph.local_graph_id;
	") ;
	$sth->execute ;
	while (my $ref = $sth->fetchrow_hashref()) {
		if ($$ref{'id'} eq 'NULL' or $$ref{'id'} eq '') {
	        	$HOST{'- Other Graphs'}->{'id'}                                           = '-' if $$ref{'id'} eq 'NULL' or $$ref{'id'} eq '';
	        	$HOST{'- Other Graphs'}->{'graph'}->{$$ref{'title_cache'}}                = $$ref{'local_graph_id'} ;
		}
		else {
	        	$HOST{$$ref{'description'}}->{'id'}                                     = $$ref{'id'} if $$ref{'id'} ne 'NULL';
	        	$HOST{$$ref{'description'}}->{'graph'}->{$$ref{'title_cache'}}          = $$ref{'local_graph_id'} ;
		}
	}
	
	# Display JSON tree

	print "[{\n" ;
	my $num_ids = keys %HOST ;
	foreach my $h (sort {$a cmp $b} keys %HOST) {
	        $num_elements = keys %{$HOST{$h}->{'graph'}} ;
	        print "\t\"key\":$node_id,\n\t\"title\":\"$h, $HOST{$h}->{'id'} ($num_elements)\",\n\"folder\":\"true\",\n\t\"state\":\"closed\",\n\t\"attributes\":{\n\t\t\"type\":\"header\"}\n,";
	        printf "\t\"children\":[\n" ;

		foreach $g (map {$_->[0]} sort {

			###################################################################################################
			# There's probably a more elegant way to do this, but the intent is to sort from left to right
			# and then upon interface numbers, if present, i.e. 1/0, 1/1, ...

                        my $fpa = '' ; my $if1 = '' ;
                        my $fpb = '' ; my $if2 = '' ;

                        $fpa = $1 if $a->[0] =~ /(.*?)\d+\/\d+/ or $a->[0] =~ /(.*?[Po|Vl])\d+/ or $a->[0] =~ /(.*?Ethernet)\d{1,}/ ;
                        $fpb = $1 if $b->[0] =~ /(.*?)\d+\/\d+/ or $b->[0] =~ /(.*?[Po|Vl])\d+/ or $b->[0] =~ /(.*?Ethernet)\d{1,}/ ;

                        # print "fpa '$fpa' ($a->[0]) - fpb '$fpb' ($b->[0])\n" ;

                        if ($fpa eq $fpb and ($a->[0] =~ /\d+\/\d+/ or $b->[0] =~ /\d+\/\d+/ or $a->[0] =~ /Vl\d+/ or $b->[0] =~ /Vl\d+/ or $a->[0] =~ /Po\d+/ or $b->[0] =~ /Po\d+/ or $a->[0] =~ /(.*?Ethernet)\d{1,}/ or $b->[0] =~ /(.*?Ethernet)\d{1,}/)) {

                                $if1 = $1 if $a->[0] =~ /(\d+\/\d+\/\d+|\d+\/\d+)/ or $a->[0] =~ /[Po|Vl](\d+)/i or $a->[0] =~ /Ethernet(\d{1,})/;
                                $if2 = $1 if $b->[0] =~ /(\d+\/\d+\/\d+|\d+\/\d+)/ or $b->[0] =~ /[Po|Vl](\d+)/i or $b->[0] =~ /Ethernet(\d{1,})/;

				# Double "digit" interface
                                $if1 =~ s/(\d+\/)(\d)/1$1\/0$2/ if $if1 =~ /^\d+\/\d$/ ;
                                $if2 =~ s/(\d+\/)(\d)/1$1\/0$2/ if $if2 =~ /^\d+\/\d$/ ;

                                $if1 =~ s/(\d+\/)(\d)/1$1\/$2/ if $if1 =~ /^\d+\/\d{2,}$/ ;
                                $if2 =~ s/(\d+\/)(\d)/1$1\/$2/ if $if2 =~ /^\d+\/\d{2,}$/ ;

				# Triple "digit" interface
                                $if1 =~ s/(\d+\/)(\d)/0$1\/0$2/ if $if1 =~ /^\d+\/\d\/\d$/ ;
                                $if2 =~ s/(\d+\/)(\d)/0$1\/0$2/ if $if2 =~ /^\d+\/\d\/\d$/ ;

                                $if1 =~ s/(\d+\/)(\d)/$1\/0$2/ if $if1 =~ /^\d+\/\d{2,}\/\d$/ ;
                                $if2 =~ s/(\d+\/)(\d)/$1\/0$2/ if $if2 =~ /^\d+\/\d{2,}\/\d$/ ;

                                $if1 =~ s/\///g ;
                                $if2 =~ s/\///g ;

                                $if1 <=> $if2 ;
                        }
                        else {
                                $a->[0] cmp $b->[0] ;
                        }
                } map {chomp;[$_,split($/)]} keys %{$HOST{$h}->{'graph'}}) {
			
	                $t = $g ; $t =~ s/$h - //g ; $t =~ s/^\s+// ;
	                $node_ref = $node_id . $node_counter ;
	                printf "\t\t\{\n\t\t\"key\":\"graph_" . $node_ref . "\",\n\t\t\"title\":\"$g ($HOST{$h}->{'graph'}->{$g})\",\n\t\t\"icon\":\"$icon_graph\",\n\t\t\"attributes\":{\n\t\t\t\"type\":\"graph\",\n\t\t\t\"local_graph_id\":\"$HOST{$h}->{'graph'}->{$g}\"\n\t\t}\n\t\t}";
	                # print "\t\t$t, $HOST{$h}->{'graph'}->{$g}\n" ;
	                $node_counter++ ;
	                if ($node_counter == $num_elements + 1) {
	                        print "]\n" ;
	                }
	                else {
	                        print ",\n"  ;
	                }
	        }
	        $node_id++ ; $node_counter = 1 ;
	        if ($node_id == $num_ids + 1) {
	                print "\t}]\n" ;
	
	        } else {
	                print "\t},{\n" ;
	        }
	}
}

sub treewalk {

	###########################################
	# Converts JSON input into "tree" data and updates the 
	# database

        my $refv = shift ;
        my $rkey = $refv->{'key'} ;
        foreach my $n (keys %{$refv}) {
                if ($n =~ /data/) {
                        $treeObj{$rkey}->{'parentid'}           = $refv->{$n}->{'parentid'} ;
                        $treeObj{$rkey}->{'local_graph_id'}     = $refv->{$n}->{'attributes'}->{'local_graph_id'} ;
                        $treeObj{$rkey}->{'graph_tree_item_id'} = $refv->{$n}->{'attributes'}->{'graph_tree_item_id'} ;
                        $treeObj{$rkey}->{'type'}               = $refv->{$n}->{'attributes'}->{'type'} ;
                        next ;
                }
                elsif ($n !~ /children/) {
                        $treeObj{$rkey}->{$n} = $refv->{$n} ;
                }
                elsif ($n =~ /children/) {
                        foreach my $c (@{$refv->{$n}}) {
                                treewalk(\%{$c}) ;
                        }
                        next ;
                }
        }

        # Process the object (node)

	my $rra_id = 0 ;
	my @key_tup = split(/\./, $rkey)  ; 
	my $tree_ID = shift @key_tup ;
	my $order_key = ''; 
 	for(my $c=0;$c<=29;$c++) {
 		$order_key .= sprintf("%03d",$key_tup[$c]) ;
 	}
	$treeObj{$rkey}->{'local_graph_id'} = 0 if !$treeObj{$rkey}->{'local_graph_id'} ;

	# keys that are all zeroes are tree references
	if ($order_key == 0) {
		$dbh->do("INSERT INTO graph_tree (id,sort_type,name) values ($rkey,1,\"$treeObj{$rkey}->{'title'}\");") if $liveRounds ;;
		next ;
	}
	else {
		$dbh->do("INSERT INTO graph_tree_items (id,graph_tree_id,local_graph_id,title,rra_id,order_key) values ('',$tree_ID," . $treeObj{$rkey}->{'local_graph_id'} . ",\"" . $treeObj{$rkey}->{'title'} . "\",5,\"" . $order_key . "\");") if $liveRounds;
	}

}


sub backup {

	###########################################
	# This will do a backup of the trees/items prior to updating converts JSON input into "tree" data and updates the 
	# database

	my @time = localtime() ;
	my $bkup_ts = (($time[5])+1900) . '.' . $time[4] . '.' . $time[3] . '-' . $time[2] . '.' . $time[1] . '.' . $time[0] ;

	open(W,">./backups/tree.$bkup_ts") ;
	print W "DELETE FROM graph_tree;\nDELETE FROM graph_tree_items;\n" ;

	my $values ;
	my @column_names ;
	my $sth= $dbh->prepare("SELECT * FROM graph_tree") ;
	$sth->execute ;
	while (my $ref = $sth->fetchrow_hashref()) {
		@column_names = keys %{$ref};
		$values = '' ;
		foreach my $col (@column_names) {
			$values .= "\"$$ref{$col}\"," ;
		}
		$values =~ s/,$// ;
		print W 'INSERT INTO graph_tree (' . join(',',@column_names) . ') values (' . $values . ');' . "\n" ;
	}

	my $sth= $dbh->prepare("SELECT * FROM graph_tree_items") ;
	$sth->execute ;
	while (my $ref = $sth->fetchrow_hashref()) {
		@column_names = keys %$ref;
		$values = '' ;
		foreach my $col (@column_names) {
			$values .= "\"$$ref{$col}\"," ;
		}
		$values =~ s/,$// ;
		print W 'INSERT INTO graph_tree_items (' . join(',',@column_names) . ') values (' . $values . ');' . "\n" ;
	}
	close(W) ;
	return "backups/tree.$bkup_ts" ;

}
