<?php

chdir('../../') ;
include("./include/auth.php");
$_SESSION["dhtml_tree"] = 'yep';
?>

<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
  <title>Cacti Graph Tree Drag'n'Drop</title>

  <link href="./lib/jquery-ui-1.11.2/themes/start/jquery-ui.css" type="text/css" rel="stylesheet" />
  <script src="./lib/jquery-1.11.1.min.js" type="text/javascript"></script>
  <script src="./lib/jquery-ui-1.11.2/jquery-ui.min.js" type="text/javascript"></script>

  <link href="./lib/fancytree-master/src/skin-xp/ui.fancytree.css" rel="stylesheet" type="text/css">
  <script src="./lib/fancytree-master/dist/jquery.fancytree-all.min.js" type="text/javascript"></script>
  <script src="./lib/contextmenu/jquery.ui-contextmenu.min.js" type="text/javascript"></script>

<style type="text/css">
ul.fancytree-container {
  height: 700px;
  overflow: auto;
  position: relative;
}

.ui-menu kbd {
	float: right;
}

.ui-menu {
	font-size: 75%;
}
  
</style>

<script type="text/javascript">

   var icon_graph  = '';
   var icon_header = 'lib/img/page_header_footer.png' ;
   var icon_tree   = 'lib/img/tree.png' ;

   CLIPBOARD = null;

   function commit_highlight() {
	  (function pulse(){
            $('#commit').delay(500).fadeOut('slow').delay(150).fadeIn('slow',pulse);
            $('#commit').css('background','#FFA347') ;
          })();
   }

   function commit_reset() {
	$('#commit').fadeIn() ; $('#commit').clearQueue() ; $('#commit').finish(); $('#commit').removeAttr('style') ;
   }

   function new_tree() {
	// Get the root node and find its children
       var new_tree = [] ;
       var last_highest = 0 ;
       var next_ID ;
       var root_node = $('#tree').fancytree('getRootNode') ;
       var num_children = root_node.getChildren() ;
       for (c=0; c < num_children.length; c++) { if (parseInt(num_children[c].key,10) > last_highest) { last_highest = parseInt(num_children[c].key,10)  } }

       next_ID = last_highest + 1 ;
       new_tree = [ { title: 'New Tree', folder: true, key: next_ID, data: [ {attributes: [ {type: 'header'} ] } ], icon: icon_tree } ];
       commit_highlight() ;
       $("#tree").fancytree("getRootNode").addChildren(new_tree).editStart() ;

   }

   function realignBranch(branchNodeID) {

     var parent_node = $("#tree").fancytree("getTree").getNodeByKey(branchNodeID.key) ;
     var node_child_count = {} ;
     var new_node_ID = '' ;

     parent_node.visit(function(node){ 
		parent_node  = node.getParent() ;

		if (/root/.test(parent_node.title)) {
			node.data.icon = icon_tree ;
			node.renderTitle();
		}
		else if ( typeof node.data.attributes != 'undefined' && node.data.attributes.type == 'header' && node.data.icon != icon_header) {
			node.data.icon = icon_header ;
			node.renderTitle();
		}

		parent_node.key = parent_node.key.replace(/root_\d+\./,'') ;

		if (typeof node_child_count[ parent_node.key ] == 'undefined') {
			node_child_count[ parent_node.key ] = 1 ;
		}
		else {
			node_child_count[ parent_node.key ] += 1 ;
		}

		new_node_ID = parent_node.key + '.' + node_child_count[ parent_node.key ] ;
		node.key    = new_node_ID ;

     });
     commit_highlight() ;

  } // realignBranch

  $(function(){
    // Source Graph Tree
    $("#source-tree").fancytree({
		extensions: ["dnd","filter"],
		checkbox: true,
		selectMode: 2,
		source: {
			url: "./cdnd.cgi?tree=avail"
		},
	 	filter: {
			mode: "hide"
		},
		dnd: {
			preventVoidMoves: true,
			preventRecursiveMoves: true,
			dragStart: function(node, data) {
				var d = data.tree.getSelectedNodes() ;
				if (d.length > 0) {
					CLIPBOARD = {mode: 'copy', data: d} ;
				}
				else {
					var n = $("#source-tree").fancytree("getNodeByKey",node.key).toDict(true) ;
					CLIPBOARD = {mode: 'copy', data: n} ;
				}

				return true;
			},
			
		},
		select: function(event, data) {
			return true ;

		},
    });

    // Verbatim copy of example, and should be cleaned up/reviewed at some point :)
    var tree = $("#source-tree").fancytree("getTree");
    $("input[name=search]").keyup(function(e){
          var n,
            leavesOnly = $("#leavesOnly").is(":checked"),
            match = $(this).val();
    
          if(e && e.which === $.ui.keyCode.ESCAPE || $.trim(match) === ""){
            $("button#btnResetSearch").click();
            return;
          }
          if($("#regex").is(":checked")) {
            // Pass function to perform match
            n = tree.filterNodes(function(node) {
              return new RegExp(match, "i").test(node.title);
            }, leavesOnly);
          } else {
            // Pass a string to perform case insensitive matching
            n = tree.filterNodes(match, leavesOnly);
          }
          $("button#btnResetSearch").attr("disabled", false);
          $("span#matches").text("(" + n + " matches)");
        }).focus();
    
        $("button#btnResetSearch").click(function(e){
          $("input[name=search]").val("");
          $("span#matches").text("");
          tree.clearFilter();
        }).attr("disabled", true);
    
        $("input#hideMode").change(function(e){
          tree.options.filter.mode = $(this).is(":checked") ? "hide" : "dimm";
          tree.clearFilter();
          $("input[name=search]").keyup();
        }).prop("checked", true);
        $("input#leavesOnly").change(function(e){
          // tree.options.filter.leavesOnly = $(this).is(":checked");
          tree.clearFilter();
          $("input[name=search]").keyup();
        });
        $("input#regex").change(function(e){
          tree.clearFilter();
          $("input[name=search]").keyup();
    });
 
    // The Cacti Tree ...
    $("#tree").fancytree({
      keyPathSeparator: ".",
      extensions: ['dnd','edit'],
      source: {
        url: "./cdnd.cgi"
      },
      edit: {
	triggerStart: ['f2', 'dblclick', 'shift+click', 'mac+enter'],
        beforeEdit: function(event, data){

		// Disable editing of graph titles
		if (!data.node.isFolder()) {
			data.node.editEnd(applyChanges=false) ;
			return false;
		}
		return true ;
	},
	edit: function(event, data){
			return true ;
	},
	beforeClose: function(event, data){
	},
	save: function(event, data){
		console.log("save...", this, data);
		data.node.setTitle(data.node.title);
		return true;
	},
	close: function(event, data){
		if( data.save ) {
			$(data.node.span).addClass("pending");
		}
	}
	
      },
      dnd: {
        preventVoidMoves: true, // Prevent dropping nodes 'before self', etc.
        preventRecursiveMoves: true, // Prevent dropping nodes on own descendants
        autoExpandMS: 200,
	focusOnClick: true,
        dragStart: function(node, data) {
          /*  This function MUST be defined to enable dragging for the tree.
              Return false to cancel dragging of node.
          */
          return true;
        },
        dragEnter: function(targetNode, data) {
	   // Prevent graph-on-graph drop
	           if (typeof targetNode.data.attributes != 'undefined' && data.node.data.attributes.type === 'graph' && targetNode.data.attributes.type === 'graph') {
	                return ['before', 'after'] ;
	           }

           return true;
        },
        dragDrop: function(targetNode, data) {

	  // Multi: ToDo -- Check to see if node 
	  if (CLIPBOARD != null && CLIPBOARD.mode === "copy" ) {
		// alert(JSON.stringify(CLIPBOARD.data, ['title','key','parentid','data','attributes','children','type','graph_tree_item_id','local_graph_id'],'\t'));
		if (targetNode.isFolder()) {
			targetNode.addChildren(CLIPBOARD.data).setActive();
		}
		else if (data.hitMode == 'before') {
			var p = targetNode.getParent() ;
			p.addChildren(CLIPBOARD.data,data.node) ;
		}
		else if (data.hitMode == 'after') {
			// There's no convenience function to add a list of children 'after'
			// a targetNode, ergo we need to cobble one together
			var p = targetNode.getParent() ;
			var nc = '' ;
			var tb = targetNode.getParent().getChildren() ;
			for (var tc=0; tc < tb.length; tc++) { if (tb[tc].key == targetNode.key) { if (typeof tb[(tc + 1)] != 'undefined') { nc = tb[(tc + 1)].key; break } else { nc = '' ; break } } }
			if (nc != '') {
				var tn = $("#tree").fancytree("getNodeByKey",nc) ;
				p.addChildren(CLIPBOARD.data,tn) ;
			}
			else {
				p.addChildren(CLIPBOARD.data) ;
			}
		}
		else {
			// More of a catch-all at this point
			var p = targetNode.getParent() ;
			p.addChildren(CLIPBOARD.data) ;
		}

   	  	realignBranch(targetNode.getParent()) ;

		// Reset checked items in source tree
		for (var sn = 0; sn < CLIPBOARD.data.length; sn++) {
			var tn = $("#source-tree").fancytree("getNodeByKey",CLIPBOARD.data[sn].key) ;
			tn.setSelected(false);
		}; 
		CLIPBOARD = null;
	  }
	  else {

		  var orig_parent   = data.otherNode.parent ; 
		  var orig_key      = data.otherNode.key ;
		  var orig_children = data.otherNode.getChildren() ;
	
	          data.otherNode.moveTo(targetNode, data.hitMode);
	   	  realignBranch(targetNode.getParent()) ;

		  // Re-align the source branch, if it share ancestry with the target
		  // if (node.tree.getRootNode() == orig_parent.tree.getRootNode()) {
		  if (targetNode.tree === orig_parent.tree) {
	  		realignBranch(orig_parent) ;
		  }

	  }

	  // We have a change -- highlight the 'commit' button
	  commit_highlight() ;

        }

      },
      activate: function(event, data) {
	return true ;
      },
      cookieId:"fancytree-cb2",
      idPrefix:"fancytree-cb2-"
    }).on("nodeCommand", function(event, data){
        var refNode, moveMode,
	tree = $(this).fancytree("getTree"),
	node = tree.getActiveNode();

	switch( data.cmd ) {
		case "addChild":
       			var new_child = { title: 'New Header', key: '', folder: 'true', data: [ {attributes: [ {type: 'header'} ] } ], icon: icon_header } ;
      			node.editCreateNode('child',new_child);
			realignBranch(node) ;
      			break;
		case "rename":
			node.editStart();
			break;
		case "remove":
			var p = node.getParent() ;
			node.remove() ;
			realignBranch(p) ;
			commit_highlight() ;
			break;
		case "nodeInfo":
			var parent_node = node.getParent() ;
			var num_children = node.getChildren() ;
			alert('parent of target ' + node.key + ' has id ' + parent_node.key) ;
			break;
        }
    }).on("keydown", function(e){
	var c = String.fromCharCode(e.which),
	   cmd = null;

        if ( e.which === $.ui.keyCode.F2) {
	   cmd = 'rename';
        }
        if ( e.which === $.ui.keyCode.DELETE ) {
	   cmd = 'remove';
        }
	else if ( c === "N" && e.ctrlKey && e.shiftKey) {
	   cmd = 'addChild';
	}
	else if ( c === "I" && e.ctrlKey && e.shiftKey) {
	   cmd = 'nodeInfo';
	}

        if (cmd) {
           $(this).trigger("nodeCommand", {cmd: cmd});
           return false;
        }
    });

    $("#tree").contextmenu({
       delegate: "span.fancytree-node",
       menu: [
         {title: "New Header&nbsp;&nbsp;&nbsp;&nbsp;    <kbd>[Ctrl+Shift+N]</kbd>", cmd: "addChild", uiIcon: "ui-icon-folder-open" },
         {title: "Edit <kbd>[F2]</kbd>", cmd: "rename", uiIcon: "ui-icon-pencil" },
         {title: "----"},
         {title: "Delete <kbd>[Del]</kbd>", cmd: "remove", uiIcon: "ui-icon-trash" },
         ],
       beforeOpen: function(event, ui) {
         var node = $.ui.fancytree.getNode(ui.target);
         $("#tree").contextmenu("enableEntry", "paste", !!CLIPBOARD);
         node.setActive();
       },
       select: function(event, ui) {
         var that = this;
         // delay the event, so the menu can close and the click event does
         // not interfere with the edit control
         setTimeout(function(){
           $(that).trigger("nodeCommand", {cmd: ui.cmd});
         }, 100);
       },
   }); // end contextmenu

  }); // end function
</script>
</head>

<body>
<table width=100% style="margin: 0px; padding: 0px;">
<tr><td valign=top width=50% style="border:solid 1px #000;">
	<div>
	<input value="NEW TREE" type="submit" onclick="new_tree();">
	<input value="REFRESH" type="reset" onclick="history.go()">
	<input value="+ +" type="submit" onclick="$('#tree').fancytree('getRootNode').visit(function(node){node.setExpanded(true);});">
	<input value="- -" type="submit" onclick="$('#tree').fancytree('getRootNode').visit(function(node){node.setExpanded(false);});">
	<button id='commit' onclick="var cgi_tree = $('#tree').fancytree('getTree').toDict() ; CGI_data = JSON.stringify(cgi_tree, ['title','key','parentid','data','attributes','children','type','graph_tree_item_id','local_graph_id'],'\t') ; $.ajax({ type: 'POST', url: './cdnd.cgi', data: CGI_data, error: function(jqXHR,textStatus,errorThrown ){alert(errorThrown)}, success: function(data){ if (data.backup != 'none') { alert(data.commit + ' - Old tree backed up as: ' + data.backup)} else { alert(data.commit) }}, dataType: 'json', contentType : 'application/json'}); commit_reset();">Commit</button>
	  <div id="tree">
	  </div>
	</div>
</td><td valign=top width=50% style="border:solid 1px #000">
	<div>
    	<label>Filter:</label>
    	<input name="search" placeholder="Filter...">
    	<button id="btnResetSearch">&times;</button>
    	<span id="matches"></span>
    	<input value="+ +" type="submit" onclick="$('#source-tree').fancytree('getRootNode').visit(function(node){node.setExpanded(true);});">
	<input value="- -" type="submit" onclick="$('#source-tree').fancytree('getRootNode').visit(function(node){node.setExpanded(false);});">
		<div id="source-tree">
		</div>
	</div>
</td></tr></table>
</body>
</html>
