<?php
/*******************************************************************************

Author ..........C.J. Fournier (though much of the credit has to go to the creator(s) of Fancytree!)
Contact ........ 555-1212
Home Site ...... Planet Earth
Program ........ "Cacti Drag-and-Drop"
Version ........ 0.1b
Purpose ........ Drag and Drop Graph Trees

*******************************************************************************/

/* register Drag-and-Drop by using PIA 2.x */
function plugin_cdnd_install () {
    api_plugin_register_hook('cdnd', 'config_arrays', 'cdnd_config_arrays', 'setup.php');
    api_plugin_register_hook('cdnd', 'config_settings', 'cdnd_config_settings', 'setup.php');
    api_plugin_register_hook('cdnd', 'draw_navigation_text', 'cdnd_draw_navigation_text', 'setup.php');
    api_plugin_register_realm('cdnd', 'cdnd.php,cdnd_tree.php', 'Plugin -> cdnd: Allow', 1);

}

function plugin_cdnd_uninstall () {

}

function plugin_cdnd_check_config () {
    return true ;
}

function plugin_cdnd_upgrade () {
    return true;
}

function plugin_cdnd_version () {
    return cdnd_version();
}

function cdnd_version ($specifically = FALSE) {

    $info = array(  'name'      => 'cdnd',
                    'version'   => '0.1b',
                    'longname'  => 'Cacti Graph Tree Drag-and-Drop',
                    'author'    => 'C.J. Fournier',
                    'email'     => 'fasterbits@gmail.com',
                    'url'       => ''
                    );
    $return = ($specifically === FALSE) ? $info : $info[$specifically];

    return $return;
}

function cdnd_config_settings () {
        global $tabs, $settings;

        if (isset($_SERVER['PHP_SELF']) && basename($_SERVER['PHP_SELF']) != 'settings.php')
                return;

        $tabs['misc'] = 'Misc';       

        $temp = array(
                'cdnd_header' => array(
                        'friendly_name' => 'Graph Tree Drag-and-Drop (CDND)',
                        'method' => 'spacer',
                        ),
                'cdnd_menu' => array(
                        'friendly_name' => 'Override "Graph Tree" menu item',
                        'description' => 'Check this to use the DnD plugin as the primary "Graph Tree" item on the menu',
                        'method' => 'checkbox',
                        ),
        );

        if (isset($settings['misc']))
                $settings['misc'] = array_merge($settings['misc'], $temp);
        else
                $settings['misc']=$temp;
}


function cdnd_config_arrays () {
    global $user_auth_realms, $user_auth_realm_filenames, $menu;
    $menu_temp = Array() ;

    /* show additional menu entries if plugin is enabled, and/or replace exiting menu item */
    $r = read_config_option('cdnd_menu');
    if (api_plugin_is_enabled('cdnd') and $r == 'on') {
	foreach ($menu["Management"] as $key => $value) {
		if ($key == 'tree.php') {
			$menu_temp["Management"]["plugins/cdnd/cdnd_tree.php"] = "Graph Trees (DnD)" ;
		}
		else {
			$menu_temp["Management"][$key] = $value ;
		}
	}
	$menu["Management"] = $menu_temp["Management"] ;
    }
    else if (api_plugin_is_enabled('cdnd')) {
        $menu["Management"]['plugins/cdnd/cdnd_tree.php']  = "Graph Trees (DND)";
    }
}

function cdnd_draw_navigation_text ($nav) {
   $nav["cdnd_tree.php:"] = array("title" => "Cacti Graph Tree Drag-and-Drop", "mapping" => "", "url" => "cdnd_tree.php", "level" => "1");
   return $nav;
}


?>
